shifts 				equ saferam
rightnrofshifts	equ saferam+1

ceasar1:
	call VPutSscreen
 db "Ceasar cipher - Intro",0
 db "The ceasar cipher is very",0
 db "simple and old. You shift",0
 db "every character cyclic",0
 db "over K places. If K=1 then",0
 db "Z",Lstore,"A,","A",Lstore,"B, B",Lstore,"C and so on.",0
 db 0FFh
	ret

ceasar2:
	call VPutSscreen
 db "Ceasar cipher - Example",0
 db "This is what happens when",0
 db "you encrypt Cleopatra",0
 db "with K=3",0
 db 0FFh
	ld bc,2*256+4
	ld (curRow),bc
	ld hl,cleopatra
	call PutS
 	ret
ceasar2_ani:
	call ceasar2
 	set fastforwardicon,(IY+asm_Flag2)
	res fastforward,(IY+asm_Flag1)
 	ld hl,cleopatra
	rst 20h
	ld bc,1*256+4
	ld (curRow),bc
	ld hl,OP1-1
	ld b,9
ceasar2_bigloop:
	push bc
	ld b,3
	ex de,hl
	ld hl,curcol
	inc (hl)
	ex de,hl
	inc hl
ceasar2_smallloop:
	push bc
	call Delay100
	ld a,(hl)
	inc a
	ld (hl),a
	B_CALL PutMap
	pop bc
	djnz ceasar2_smallloop
	pop bc
	djnz ceasar2_bigloop
	res fastforwardicon,(IY+asm_Flag2)
	ret
cleopatra:
 db "CLEOPATRA",0

ceasar3:
	call VPutSscreen
 db "Ceasar cipher - Crack1",0
 db "The Ceasar cipher can be",0
 db "cracked easily. You just",0
 db "decode the message for",0
 db "K=1 to K=25 and look for an",0
 db "output that's in English.",0
 db 0FFh
	ret

ceasar4:
	call VPutSscreen
 db "Ceasar cipher - Crack2",0
 db "Let's try to crack a",0
 db "message",0
 db 0FFh
 	ld hl,1*256+4
	ld (currow),hl
	ld hl,ceasar4_str
	call PutS
	ret
ceasar4_strlength:
 db 8
ceasar4_str:
 db "RCUUYQTF",0

ceasar4_ani:
	set fastforwardicon,(IY+asm_flag2)
	call ceasar4
	res fastforward,(IY+asm_flag1)
	ld hl,ceasar4_strlength
	ld de,tempswaparea
	ld bc,10
	ldir
	ld b,2
ceasar4_loop:
	push bc
	ld hl,1*256+4
	ld (currow),hl
	ld c,0FFh
	call ceasar_shift
	ld a,80h+22
	B_CALL ClearRow
	VPutSScreen 4,23,"Trying K="
	pop bc
	push bc
	ld a,3
	sub b
	res textWrite, (IY + sGrFlags)
	call VDisplayA
	set textWrite, (IY + sGrFlags)
	ld hl,tempswaparea+1
	ld b,8
ceasar4_subloop:
	push bc
	call Delay100
	pop bc
	ld a,(hl)
	inc hl
	B_CALL PutC
	djnz ceasar4_subloop
	pop bc
	djnz ceasar4_loop
	ld a,80h+22
	B_CALL ClearRow
	VPutSScreen 4,23,"Cracked it"
	res fastforwardicon,(IY+asm_flag2)
	ret


ceasar5:
	pop hl ;delete ret
ceasar5_nopop:
	res noicon,(IY+asm_Flag2)
	ld a,1
ceasar_redraw:
	ld (currentselected),a
	B_CALL GrBufClr
	ld b,2
	push bc
	call vakjes
	pop bc
	call vakjecijfers
	ld a,(currentselected)
	push af
	call vakjeinvert
	pop af
	dec a
	jr nz,ceasar5_display2
	VPutSI 16,12,"Crack with help"
	VPutS 18,20,"Crack a code using"
	VPutS 18,27,"a decrypt program"
	ld hl,12*256+11
	ld de,19*256+15
	call fillrect
	ld hl,18*256+15
	ld bc,35*256+82
	call Drawrect
	jr ceasar5_display1
ceasar5_display2:
	VPutSI 16,22,"Crack manually"
	VPutS 18,30,"Crack a code"
	VPutS 18,37,"manually"
	ld hl,22*256+11
	ld de,29*256+15
	call fillrect
	ld hl,28*256+15
	ld bc,45*256+82
	call Drawrect
ceasar5_display1:
	call VPutSscreen
 db "Ceasar cipher - Exercises",0
 db 0
 db 0FFh
ceasar5_keyloop:
	B_CALL GetKey ;temporarily to allow screenshots
	cp kUp
	jr z,ceasar5_up
	cp kDown
	jr z,ceasar5_down
	cp kEnter
	jr z,ceasar5_enter
	cp k1
	jr z,ceasar_decryptprog
	cp k2
	jr z,ceasar_decryptman
	call readkeys
	jr ceasar5_keyloop

ceasar5_up:
	ld a,1
	jr ceasar_redraw
ceasar5_down:
	ld a,2
	jr ceasar_redraw

ceasar5_enter:
	ld a,(currentselected)
	dec a
	jr z,ceasar_decryptprog
	jr ceasar_decryptman

ceasar_decryptprog:
	set noicon,(IY+asm_Flag2)
	B_CALL GrBufClr
	ld hl,quitstr
	ld a,0
	call Displaykey15
	ld hl,checkstr
	ld a,18
	ld c,35
	call Displaykey
	call VPutSscreen
 db "Ceasar cipher",0
 db "Press up or down to try",0
 db "another value of K.",0
 db 0FFh
	call ceasar_decrypt_randstr
	PutS 2,5,"K="
	xor a
	ld (shifts),a
ceasar_decryptprog_shiftentry:
	ld hl,2*256+4
	ld (curRow),hl
	ld hl,tempSwapArea+1
	B_CALL PutS
	ld hl,4*256+5
	ld (curRow),hl
	ld a,(shifts)
	call DisplayA
	ld a," "
	B_CALL PutMap
ceasar_decryptprog_keyloop:
 	B_CALL GetKey
	cp kUp
	jr z,ceasar_decryptprog_up
	cp kDown
	jr z,ceasar_decryptprog_down
	cp kEnter
	jr z,ceasar_decryptprog_enter
	cp kWindow
	jr z,ceasar_decryptprog_enter
	cp kZoom
	jr z,ceasar_decryptprog_enter
	call ceasar_decrypt_readkeys
	jr ceasar_decryptprog_keyloop
ceasar_decryptprog_up:
	ld c,0FFh
	jr ceasar_decryptprog_shiftcont
ceasar_decryptprog_down:
	ld c,1
ceasar_decryptprog_shiftcont:
	call ceasar_shift
	jr ceasar_decryptprog_shiftentry
ceasar_decryptprog_enter:
	ld hl,2*256+6
	ld (currow),hl
	ld hl,(shifts)
	ld a,h
	cp l
	jr nz,ceasar_decryptprog_enter_incorrect
	ld hl,correct
	jr ceasar_decryptprog_enter_correct
ceasar_decryptprog_enter_incorrect:
	ld hl,incorrect
ceasar_decryptprog_enter_correct:
	call PutS
continuestrminus5:
	VPutSScreen 20,57,"  CONTINUE"
ceasar_decryptprog_enter_keyloop:
	B_CALL GetKey
	cp kWindow
	jr z,ceasar_decryptprog
	cp kZoom
	jr z,ceasar_decryptprog
	cp kEnter
	jr z,ceasar_decryptprog
	call ceasar_decrypt_readkeys
	jr ceasar_decryptprog_enter_keyloop
	
ceasar_decrypt_readkeys:
	pop hl
	cp kLeft
	jr z,ceasar5_nopop
	cp kRight
	jr z,ceasar5_nopop
	cp kYequ
	jr z,ceasar5_nopop
	push hl
	jr readkeys

correct:
 db "Correct!",0
incorrect:
 db "Incorrect!",0

checkstr:
 db "     CHECK K",0

ceasar_decrypt_randstr:
	B_CALL Random
	ld de,(OP1+2)
	ld a,d
	and 0Fh
	add a
	ld b,0
	ld c,a
	ld hl,ceasar_decrypt_strtable
	add hl,bc
	call LdHLInd
	ld a,e
	and 0Fh
	or a
	jr z,ceasar_decrypt_randstr_skipstrloop
	dec a
	srl a ;only five strs
	ld b,a
	ld c,0FFh
	jr z,ceasar_decrypt_randstr_skipstrloop
	xor a
ceasar_decrypt_randstr_findstrloop:
	cpir
	djnz ceasar_decrypt_randstr_findstrloop
ceasar_decrypt_randstr_skipstrloop:
	call StrCopy
	ex de,hl
	B_CALL StrLength
	dec hl
	ld (hl),c ;length of str
	ld de,(OP1+4)
	ld a,e
	and 0Fh
	ld e,a
	ld a,d
	and 0Fh
	add a
	ld d,a
	add a
	add a
	add d ;mult by 10
	add e ;nr between 0 and 99
	inc a
	ld h,0
	ld l,a
	ld a,26
	B_CALL DivHLByA
	or a
	jr nz,ceasar_decrypt_randstr_dontinc
	ld a,16 ;42 mod 16 :)
ceasar_decrypt_randstr_dontinc:
	push af
	ld b,a
	ld a,26
	sub b
	ld (rightnrofshifts),a
	pop af
	ld b,a
	ld c,0FFh
ceasar_decrypt_randstr_shiftloop:
	push bc
	call ceasar_shift
	pop bc
	djnz ceasar_decrypt_randstr_shiftloop
	ret
ceasar_shift:
	ld hl,shifts
	ld a,c
	dec a
	jr z,ceasar_shift_one
	ld a,1
	jr ceasar_shift_minusone
ceasar_shift_one:
	ld a,0FFh
ceasar_shift_minusone:
	add (hl)
;	ld a,(hl)
;	add c
	cp 0FFh
	jr nz,ceasar_shift_notFF
	ld a,25
ceasar_shift_notFF:
	cp 26
	jr nz,ceasar_shift_not27
	ld a,0
ceasar_shift_not27:
	ld (hl),a
	ld hl,tempSwapArea
	ld b,(hl)
ceasar_shift_loop:
	inc hl
	ld a,(hl)
	add c
	cp "A"-1
	jr nz,ceasar_shift_askip
	ld a,"Z"
ceasar_shift_askip:
	cp "Z"+1
	jr nz,ceasar_shift_zskip
	ld a,"A"
ceasar_shift_zskip:
	ld (hl),a
	djnz ceasar_shift_loop
	ret
ceasar_decrypt_strtable:
 dw ceasar_decrypt_str0
 dw ceasar_decrypt_str1
 dw ceasar_decrypt_str2
 dw ceasar_decrypt_str3
 dw ceasar_decrypt_str4
 dw ceasar_decrypt_str5
 dw ceasar_decrypt_str6
 dw ceasar_decrypt_str7
 dw ceasar_decrypt_str8
 dw ceasar_decrypt_str9
ceasar_decrypt_str0:
 db "HUNGER",0,"FREEZER",0,"SOUND",0,"SOUP",0,"OUTDOOR",0
ceasar_decrypt_str1:
 db "MANIAC",0,"MANKIND",0,"DOLPHIN",0,"DATUM",0,"MIRROR",0
ceasar_decrypt_str2:
 db "NICKEL",0,"TOILET",0,"MATHS",0,"PUBLIC",0,"SEQUENCE",0
ceasar_decrypt_str3:
 db "SHORT",0,"SMOKE",0,"TABLE",0,"TELESCOPE",0,"PAINTING",0
ceasar_decrypt_str4:
 db "RADIO",0,"CASTLE",0,"SPRING",0,"WHEEL",0,"ANSWER",0
ceasar_decrypt_str5:
 db "CLASS",0,"TEACHER",0,"AGENCY",0,"REVENGE",0,"DRESSCODE",0
ceasar_decrypt_str6:
 db "TEATIME",0,"BUNNY",0,"HELMET",0,"CAUTION",0,"DOUBT",0
ceasar_decrypt_str7:
 db "EYETEST",0,"FELONY",0,"MUSIC",0,"EMAIL",0,"TOENAIL",0
ceasar_decrypt_str8:
 db "RING",0,"FISH",0,"MACHINE",0,"SCHOOL",0,"FLYER",0
ceasar_decrypt_str9:
 db "GOLDRUSH",0,"HANDBRAKE",0,"SIMPLE",0,"POWER",0,"INVEST",0

ceasar_decryptman:
	set noicon,(IY+asm_Flag2)
	B_CALL GrBufClr
	ld hl,quitstr
	ld a,0
	call Displaykey15
	ld hl,ansstr
	ld a,18
	call Displaykey15
	call VPutSscreen
 db "Ceasar cipher",0
 db "Try to decrypt manually.",0
 db 0FFh
 	call ceasar_decrypt_randstr
	ld hl,2*256+3
	ld (curRow),hl
	ld hl,tempSwapArea+1
	B_CALL PutS
ceasar_decryptman_keyloop:
 	B_CALL GetKey
	cp kEnter
	jr z,ceasar_decryptman_displayans
	cp kWindow
	jr z,ceasar_decryptman_displayans
	call ceasar_decrypt_readkeys
	jr ceasar_decryptman_keyloop

ceasar_decryptman_displayans:
	ld a,(rightnrofshifts)
	push af
	ld b,a
	ld c,0FFh
ceasar_decryptman_displayans_shiftloop:
	push bc
	call ceasar_shift
	pop bc
	djnz ceasar_decryptman_displayans_shiftloop
	ld hl,2*256+4
	ld (curRow),hl
	ld hl,tempSwapArea+1
	B_CALL PutS
	PutS 2,5,"K="
	pop af
	call DisplayA
	VPutSScreen 20,57,"CONT"
	ld bc,35*256+6
	B_CALL PointOn
	B_CALL GetKey
	call ceasar_decrypt_readkeys
	jr ceasar_decryptman

ansstr:
 db "  ANS",0